; EXAMPLE 1: makro INSIDER UserReg
;
; Makro vypise nedestruktivne UserReg na displej Insideru.
; Nespotrebuje se zde zadny registr ani W, nespotrebuje se zadna uroven
; STACKU. Narocnost makra je 49 instrukci, bude vykonavano 
; 49 instrukcnich cyklu.
;-----------------------------------------------------------------------
;       DEFINICE HARDWARE
        list    F=inhx8m, p=16F84, r=hex        ; pro prekladac
        __config        3ffBh                   ; pojistky
;-----------------------------------------------------------------------
;       User Pins                               Tris: 3F
#define     ICLK    portb,7  ;
#define     IDATA   portb,6  ;
;       Special Function Registers
INDF        equ     00h     ; sdileny pro obe banky
TMR0        equ     01h
ROption     equ     01h
PCL         equ     02h     ; sdileny pro obe banky
STATUS      equ     03h     ; sdileny pro obe banky
FSR         equ     04h     ; sdileny pro obe banky
Porta       equ     05h     ; bank 0
Portb       equ     06h     ; bank 0
Trisa       equ     05h     ; bank 1
Trisb       equ     06h     ; bank 1

#define zero    status,2    ; Zero flag
#define DC      status,1    ; DC flag
#define carry   status,0    ; C flag

;       Uzivatelske registry
UserReg1 set         0x0C   ; uzivatelsky registr
UserReg2 set         0x0D   ; uzivatelsky registr
;-----------------------------------------------------------------------
;       definice maker
Insider macro OutReg        ; makro vypise nedestruknivne obsah OutReg na
                            ; displej Insideru, jehoz vsechny prepinace jsou 0
                            ; (CP=0,EU=0,EF=0,EP=0)
        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 7
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 6
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 5
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 4
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 3
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 2
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 1
        btfsc   carry
        bsf     IDATA
        bcf     ICLK

        bsf     ICLK
        rlf     OutReg,f
        bcf     IDATA       ; bit 0
        btfsc   carry
        bsf     IDATA
        bcf     ICLK
        bsf     ICLK
        endm

bnk0    macro               ; makro nastavi banku 0
        bcf     status,5
        endm
bnk1    macro               ; makro nastavi banku 1
        bsf     status,5
        endm
;-----------------------------------------------------------------------
        org     0x00
        goto    Start       ; 1. instrukce - skok na zacatek programu

        org     0x05        ; zacatek programu
Start:  bnk1
        movlw   0x3F
        movwf   TRISB       ; nastaveni smeru portu B
        bnk0                ; (pin 0,6,7 output, pin 1 az 5 input)

        movlw   0x1A
        movwf   UserReg1    ; UserReg1 obsahuje nejaka uzivatelska data
                            ; (v tomto pripade 0x1A)
        movlw   0x3F
        movwf   UserReg2    ; UserReg2 obsahuje nejaka uzivatelska data
                            ; (v tomto pripade 0x3F)
        nop
        nop                 ; ...kdekoliv v programu

        Insider UserReg1    ; Nedestruktivne vypiseme hodnotu UserReg1 na displeji

        nop
        nop                 ; ...kdekoliv v programu

        Insider UserReg2    ; Nedestruktivne vypiseme hodnotu UserReg2 na displeji

        nop
        nop                 ; ...uzivatelsky program pokracuje
Stop:   goto Stop
        end
